Index: branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6101)
+++ branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 6772)
@@ -1116,339 +642,65 @@
             CALL wrk_alloc( jpi, jpj, jpk, zmask )
 
-            SELECT CASE ( cd_type )
-              CASE( 'W' )
-                  zmask(:,:,1) = p_mask(:,:,1) 
-                  DO jk = 2, jpk
-                     zmask(:,:,jk) = p_mask(:,:,jk-1) 
-                  ENDDO
-              CASE ( 'T' )
-                  DO jk = 1, jpk
-                     zmask(:,:,jk) = p_mask(:,:,jk) 
-                  ENDDO
-            END SELECT
+            DO jk = 1, jpk
+               zmask(:,:,jk) = p_mask(:,:,jk) 
+            ENDDO
 
             SELECT CASE ( cd_type )
             
                CASE( 'T', 'W' )
-         
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO jk = 1, jpk           
-                           DO ji = nistr, niend, nn_factx
-                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2        
-                              zflcrs =  &
-                                & MAX( p_fld(ji  ,je_2,jk) * zmask(ji  ,je_2,jk) - ( 1.- zmask(ji  ,je_2,jk) ) * r_inf ,  &
-                                &      p_fld(ji+1,je_2,jk) * zmask(ji+1,je_2,jk) - ( 1.- zmask(ji+1,je_2,jk) ) * r_inf ,  &
-                                &      p_fld(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) - ( 1.- zmask(ji+2,je_2,jk) ) * r_inf  )
-                              !
-                              p_fld_crs(ii,2,jk) = zflcrs
-                           ENDDO
-                        ENDDO
-                      ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO jk = 1, jpk           
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-                           zflcrs =  &
-                             & MAX( p_fld(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk) - ( 1.- zmask(ji  ,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk) - ( 1.- zmask(ji+1,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk) - ( 1.- zmask(ji+2,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk) - ( 1.- zmask(ji  ,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk) - ( 1.- zmask(ji+1,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk) - ( 1.- zmask(ji+2,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk) - ( 1.- zmask(ji  ,je_2+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk) - ( 1.- zmask(ji+1,je_2+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk) - ( 1.- zmask(ji+2,je_2+2,jk) ) * r_inf   )
-                           !
-                           p_fld_crs(ii,2,jk) = zflcrs
+        
+                  DO jk = 1, jpk
+                     DO jj  = nldj_crs,nlej_crs
+                        ijjs = mjs_crs(jj)
+                        ijje = mje_crs(jj)
+                        DO ji = nldi_crs, nlei_crs
+                           ijis = mis_crs(ji)
+                           ijie = mie_crs(ji)
+                           p_fld_crs(ji,jj,jk) = MAXVAL( p_fld(ijis:ijie,ijjs:ijje,jk) * zmask(ijis:ijie,ijjs:ijje,jk) - &
+                                                       & ( ( 1._wp - zmask(ijis:ijie,ijjs:ijje,jk))* r_inf )                )
                         ENDDO
                      ENDDO
-                  ENDIF
-                  !
-                  DO jk = 1, jpk           
-                     DO jj  = njstr, njend, nn_facty
-                        DO ji = nistr, niend, nn_factx
-                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                           ij  = ( jj - njstr ) * rfacty_r + 3
-                           zflcrs =  &
-                             & MAX( p_fld(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk) - ( 1.- zmask(ji  ,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk) - ( 1.- zmask(ji+1,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk) - ( 1.- zmask(ji+2,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk) - ( 1.- zmask(ji  ,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk) - ( 1.- zmask(ji+1,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk) - ( 1.- zmask(ji+2,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk) - ( 1.- zmask(ji  ,jj+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk) - ( 1.- zmask(ji+1,jj+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk) - ( 1.- zmask(ji+2,jj+2,jk) ) * r_inf   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO   
-            
+                  ENDDO
+ 
                CASE( 'V' )
-
-!                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        ijje = mje_crs(2)
-!                      ENDIF
-!                  ELSE
-!                     ijje = mjs_crs(2)
-!                  ENDIF
-!
-!                  DO jk = 1, jpk
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                        zflcrs = &
-!                          & MAX( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                          &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                          &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
-!                          !
-!                        p_fld_crs(ii,2,jk) = zflcrs
-!                     ENDDO
-!                  ENDDO
-!                  !
-!                  DO jk = 1, jpk           
-!                     DO jj  = njstr, njend, nn_facty
-!                        DO ji = nistr, niend, nn_factx
-!                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-!                           ij  = ( jj - njstr ) * rfacty_r + 3
-!                           ijje = mje_crs(ij)
-!                           !                  
-!                           zflcrs = &
-!                             & MAX( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                             &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                             &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) - ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
-!                           !
-!                           p_fld_crs(ii,ij,jk) = zflcrs
-!                           !
-!                        ENDDO      
-!                     ENDDO
-!                  ENDDO   
                   CALL ctl_stop('MAX operator and V case not available')
             
                CASE( 'U' )
-
-!                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        je_2 = mje_crs(2)
-!                        DO jk = 1, jpk           
-!                           DO ji = nistr, niend, nn_factx
-!                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2  
-!                              ijie = mie_crs(ii)
-!                              zflcrs = p_fld(ijie,je_2,jk) * p_mask(ijie,je_2,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf 
-!                              !
-!                              p_fld_crs(ii,2,jk) = zflcrs
-!                            ENDDO
-!                        ENDDO
-!                      ENDIF
-!                  ELSE
-!                     je_2 = mjs_crs(2)
-!                     DO jk = 1, jpk           
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-!                           ijie = mie_crs(ii)
-!                           zflcrs = &
-!                             & MAX( p_fld(ijie,je_2  ,jk) * p_mask(ijie,je_2  ,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,je_2+1,jk) * p_mask(ijie,je_2+1,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,je_2+2,jk) * p_mask(ijie,je_2+2,jk) - ( 1.- p_mask(ijie,je_2,jk) ) * r_inf  )
-!                            !
-!                           p_fld_crs(ii,2,jk) = zflcrs
-!                        ENDDO
-!                     ENDDO
-!                  ENDIF
-!                  !
-!                  DO jk = 1, jpk           
-!                     DO jj  = njstr, njend, nn_facty
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                           ij   = ( jj - njstr ) * rfacty_r + 3
-!                           ijie = mie_crs(ii)
-!                           zflcrs =  &
-!                             & MAX( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) - ( 1.- p_mask(ijie,jj,jk) ) * r_inf  )
-!                           ! 
-!                           p_fld_crs(ii,ij,jk) = zflcrs
-!                           ! 
-!                        ENDDO      
-!                     ENDDO
-!                  ENDDO   
                   CALL ctl_stop('MAX operator and U case not available')
 
-              END SELECT
-
-              CALL wrk_dealloc( jpi, jpj, jpk, zmask )
+            END SELECT
+
+            CALL wrk_dealloc( jpi, jpj, jpk, zmask )
 
          CASE ( 'MIN' )      !   Search the min of unmasked grid cells
 
             CALL wrk_alloc( jpi, jpj, jpk, zmask )
-
-            !SELECT CASE ( cd_type )
-            !  CASE( 'W' )
-            !      !cbr ?????????????????????????????
-            !      zmask(:,:,1) = p_mask(:,:,1) 
-            !      DO jk = 2, jpk
-            !         zmask(:,:,jk) = p_mask(:,:,jk-1) 
-            !      ENDDO
-            !  CASE ( 'T' )
+            DO jk = 1, jpk
+               zmask(:,:,jk) = p_mask(:,:,jk)
+            ENDDO
+
+            SELECT CASE ( cd_type )
+
+               CASE( 'T', 'W' )
+
                   DO jk = 1, jpk
-                     zmask(:,:,jk) = p_mask(:,:,jk) 
-                  ENDDO
-            !END SELECT
-
-            SELECT CASE ( cd_type )
-
-               CASE( 'T', 'W' )
-         
-                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                        je_2 = mje_crs(2)
-                        DO jk = 1, jpk           
-                           DO ji = nistr, niend, nn_factx
-                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2        
-                              zflcrs =  &
-                                & MIN( p_fld(ji  ,je_2,jk) * zmask(ji  ,je_2,jk) + ( 1.- zmask(ji  ,je_2,jk) ) * r_inf ,  &
-                                &      p_fld(ji+1,je_2,jk) * zmask(ji+1,je_2,jk) + ( 1.- zmask(ji+1,je_2,jk) ) * r_inf ,  &
-                                &      p_fld(ji+2,je_2,jk) * zmask(ji+2,je_2,jk) + ( 1.- zmask(ji+2,je_2,jk) ) * r_inf  )
-                              !
-                              p_fld_crs(ii,2,jk) = zflcrs
-                           ENDDO
-                        ENDDO
-                      ENDIF
-                  ELSE
-                     je_2 = mjs_crs(2)
-                     DO jk = 1, jpk           
-                        DO ji = nistr, niend, nn_factx
-                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-                           zflcrs =  &
-                             & MIN( p_fld(ji  ,je_2  ,jk) * zmask(ji  ,je_2  ,jk) + ( 1.- zmask(ji  ,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2  ,jk) * zmask(ji+1,je_2  ,jk) + ( 1.- zmask(ji+1,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2  ,jk) * zmask(ji+2,je_2  ,jk) + ( 1.- zmask(ji+2,je_2  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,je_2+1,jk) * zmask(ji  ,je_2+1,jk) + ( 1.- zmask(ji  ,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2+1,jk) * zmask(ji+1,je_2+1,jk) + ( 1.- zmask(ji+1,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2+1,jk) * zmask(ji+2,je_2+1,jk) + ( 1.- zmask(ji+2,je_2+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,je_2+2,jk) * zmask(ji  ,je_2+2,jk) + ( 1.- zmask(ji  ,je_2+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,je_2+2,jk) * zmask(ji+1,je_2+2,jk) + ( 1.- zmask(ji+1,je_2+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,je_2+2,jk) * zmask(ji+2,je_2+2,jk) + ( 1.- zmask(ji+2,je_2+2,jk) ) * r_inf   )
-                           !
-                           p_fld_crs(ii,2,jk) = zflcrs
+                     DO jj  = nldj_crs,nlej_crs
+                        ijjs = mjs_crs(jj)
+                        ijje = mje_crs(jj)
+                        DO ji = nldi_crs, nlei_crs
+                           ijis = mis_crs(ji)
+                           ijie = mie_crs(ji)
+
+                           p_fld_crs(ji,jj,jk) = MINVAL( p_fld(ijis:ijie,ijjs:ijje,jk) * zmask(ijis:ijie,ijjs:ijje,jk) + &
+                                                       & ( 1._wp - zmask(ijis:ijie,ijjs:ijje,jk)* r_inf )                )
                         ENDDO
                      ENDDO
-                  ENDIF
-                  !
-                  DO jk = 1, jpk           
-                     DO jj  = njstr, njend, nn_facty
-                        DO ji = nistr, niend, nn_factx
-                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                           ij  = ( jj - njstr ) * rfacty_r + 3
-                           zflcrs =  &
-                             & MIN( p_fld(ji  ,jj  ,jk) * zmask(ji  ,jj  ,jk) + ( 1.- zmask(ji  ,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj  ,jk) * zmask(ji+1,jj  ,jk) + ( 1.- zmask(ji+1,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj  ,jk) * zmask(ji+2,jj  ,jk) + ( 1.- zmask(ji+2,jj  ,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,jj+1,jk) * zmask(ji  ,jj+1,jk) + ( 1.- zmask(ji  ,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj+1,jk) * zmask(ji+1,jj+1,jk) + ( 1.- zmask(ji+1,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj+1,jk) * zmask(ji+2,jj+1,jk) + ( 1.- zmask(ji+2,jj+1,jk) ) * r_inf ,  &
-                             &      p_fld(ji  ,jj+2,jk) * zmask(ji  ,jj+2,jk) + ( 1.- zmask(ji  ,jj+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+1,jj+2,jk) * zmask(ji+1,jj+2,jk) + ( 1.- zmask(ji+1,jj+2,jk) ) * r_inf ,  &
-                             &      p_fld(ji+2,jj+2,jk) * zmask(ji+2,jj+2,jk) + ( 1.- zmask(ji+2,jj+2,jk) ) * r_inf   )
-                           !
-                           p_fld_crs(ii,ij,jk) = zflcrs
-                           !
-                        ENDDO      
-                     ENDDO
-                  ENDDO   
+                  ENDDO
+
             
                CASE( 'V' )
-
-!                  IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        ijje = mje_crs(2)
-!                      ENDIF
-!                  ELSE
-!                     ijje = mjs_crs(2)
-!                  ENDIF
-!
-!                  DO jk = 1, jpk
-!                     DO ji = nistr, niend, nn_factx
-!                        ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                        zflcrs = &
-!                          & MIN( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                          &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                          &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
-!                          !
-!                        p_fld_crs(ii,2,jk) = zflcrs
-!                     ENDDO
-!                  ENDDO
-!                  !
-!                  DO jk = 1, jpk           
-!                     DO jj  = njstr, njend, nn_facty
-!                        DO ji = nistr, niend, nn_factx
-!                           ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-!                           ij  = ( jj - njstr ) * rfacty_r + 3
-!                           ijje = mje_crs(ij)
-!                           zflcrs = &
-!                             & MIN( p_fld(ji  ,ijje,jk) * p_mask(ji  ,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                             &      p_fld(ji+1,ijje,jk) * p_mask(ji+1,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf ,  &
-!                             &      p_fld(ji+2,ijje,jk) * p_mask(ji+2,ijje,jk) + ( 1.- p_mask(ji,ijje,jk) ) * r_inf )
-!                           !
-!                           p_fld_crs(ii,ij,jk) = zflcrs
-!                           !
-!                        ENDDO      
-!                     ENDDO
-!                  ENDDO   
                   CALL ctl_stop('MIN operator and V case not available')
-
             
                CASE( 'U' )
-
-!                 IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-!                     IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-!                        je_2 = mje_crs(2)
-!                        DO jk = 1, jpk           
-!                           DO ji = nistr, niend, nn_factx
-!                              ii   = ( ji - mis_crs(2) ) * rfactx_r + 2  
-!                              ijie = mie_crs(ii)
-!                              zflcrs = p_fld(ijie,je_2,jk) * p_mask(ijie,je_2,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf 
-!                              !
-!                              p_fld_crs(ii,2,jk) = zflcrs
-!                            ENDDO
-!                        ENDDO
-!                      ENDIF
-!                  ELSE
-!                     je_2 = mjs_crs(2)
-!                     DO jk = 1, jpk           
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-!                           ijie = mie_crs(ii)
-!                           zflcrs = &
-!                             & MIN( p_fld(ijie,je_2  ,jk) * p_mask(ijie,je_2  ,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,je_2+1,jk) * p_mask(ijie,je_2+1,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,je_2+2,jk) * p_mask(ijie,je_2+2,jk) + ( 1.- p_mask(ijie,je_2,jk) ) * r_inf  )
-!                            !
-!                           p_fld_crs(ii,2,jk) = zflcrs
-!                        ENDDO
-!                     ENDDO
-!                  ENDIF
-!                  !
-!                  DO jk = 1, jpk           
-!                     DO jj  = njstr, njend, nn_facty
-!                        DO ji = nistr, niend, nn_factx
-!                           ii   = ( ji - mis_crs(2) ) * rfactx_r + 2     
-!                           ij   = ( jj - njstr ) * rfacty_r + 3
-!                           ijie = mie_crs(ii)
-!                           zflcrs = &
-!                             & MIN( p_fld(ijie,jj  ,jk) * p_mask(ijie,jj  ,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,jj+1,jk) * p_mask(ijie,jj+1,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf ,  &
-!                             &      p_fld(ijie,jj+2,jk) * p_mask(ijie,jj+2,jk) + ( 1.- p_mask(ijie,jj,jk) ) * r_inf  )
-!                           ! 
-!                           p_fld_crs(ii,ij,jk) = zflcrs
-!                           ! 
-!                        ENDDO      
-!                     ENDDO
-!                  ENDDO   
                   CALL ctl_stop('MIN operator and U case not available')
           
@@ -1459,7 +711,5 @@
          END SELECT
          !
-         !IF(narea==267)WRITE(5000+narea,*)"vn_crs(17,5,74) avt lbc = ",p_fld(17,5,74)
          CALL crs_lbc_lnk( p_fld_crs, cd_type, psgn )
-         !IF(narea==267)WRITE(5000+narea,*)"vn_crs(17,5,74) apr lbc = ",p_fld(17,5,74)
          !
     END SUBROUTINE crs_dom_ope_3d
@@ -1504,5 +754,5 @@
       !! Local variables
       INTEGER  :: ji, jj, jk                 ! dummy loop indices
-      INTEGER  :: ijie, ijje, ii, ij, je_2
+      INTEGER ::  ijis, ijie, ijjs, ijje
       REAL(wp) :: zflcrs, zsfcrs   
       REAL(wp), DIMENSION(:,:), POINTER :: zsurfmsk   
@@ -1515,70 +765,24 @@
       
         CASE ( 'VOL' )
-      
+
             CALL wrk_alloc( jpi, jpj, zsurfmsk )
             zsurfmsk(:,:) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1)
 
-            IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
-               IF( mje_crs(2) - mjs_crs(2) == 1 ) THEN
-                  je_2 = mje_crs(2)
-                  DO ji = nistr, niend, nn_factx
-                     ii   = ( ji - mis_crs(2) ) * rfactx_r + 2       
-                     zflcrs =  p_fld(ji  ,je_2) * zsurfmsk(ji  ,je_2)   &
-                       &     + p_fld(ji+1,je_2) * zsurfmsk(ji+1,je_2)   &
-                       &     + p_fld(ji+2,je_2) * zsurfmsk(ji+2,je_2) 
-
-                     zsfcrs =  zsurfmsk(ji,je_2) + zsurfmsk(ji+1,je_2) + zsurfmsk(ji+2,je_2) 
-                     !
-                     p_fld_crs(ii,2) = zflcrs
-                     IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2) = zflcrs / zsfcrs
-                  ENDDO
-               ENDIF
-            ELSE
-               je_2 = mjs_crs(2)
-               DO ji = nistr, niend, nn_factx
-                  ii   = ( ji - mis_crs(2) ) * rfactx_r + 2   
-                  zflcrs =  p_fld(ji  ,je_2  ) * zsurfmsk(ji  ,je_2  ) &
-                    &     + p_fld(ji+1,je_2  ) * zsurfmsk(ji+1,je_2  ) &
-                    &     + p_fld(ji+2,je_2  ) * zsurfmsk(ji+2,je_2  ) &
-                    &     + p_fld(ji  ,je_2+1) * zsurfmsk(ji  ,je_2+1) &
-                    &     + p_fld(ji+1,je_2+1) * zsurfmsk(ji+1,je_2+1) &
-                    &     + p_fld(ji+2,je_2+1) * zsurfmsk(ji+2,je_2+1) &
-                    &     + p_fld(ji  ,je_2+2) * zsurfmsk(ji  ,je_2+2) &
-                    &     + p_fld(ji+1,je_2+2) * zsurfmsk(ji+1,je_2+2) &
-                    &     + p_fld(ji+2,je_2+2) * zsurfmsk(ji+2,je_2+2) 
-
-                   zsfcrs =  zsurfmsk(ji,je_2  ) + zsurfmsk(ji+1,je_2  ) + zsurfmsk(ji+2,je_2  ) &
-                     &     + zsurfmsk(ji,je_2+1) + zsurfmsk(ji+1,je_2+1) + zsurfmsk(ji+2,je_2+1) &
-                     &     + zsurfmsk(ji,je_2+2) + zsurfmsk(ji+1,je_2+2) + zsurfmsk(ji+2,je_2+2) 
-                    !
-                    p_fld_crs(ii,2) = zflcrs
-                    IF( zsfcrs /= 0.0 )  p_fld_crs(ii,2) = zflcrs / zsfcrs
-                ENDDO
-            ENDIF
-                  !
-            DO jj  = njstr, njend, nn_facty
-               DO ji = nistr, niend, nn_factx
-                  ii  = ( ji - mis_crs(2) ) * rfactx_r + 2                 ! cordinate in parent grid
-                  ij  = ( jj - njstr ) * rfacty_r + 3
-                  zflcrs =  p_fld(ji  ,jj  ) * zsurfmsk(ji  ,jj  ) &
-                    &     + p_fld(ji+1,jj  ) * zsurfmsk(ji+1,jj  ) &
-                    &     + p_fld(ji+2,jj  ) * zsurfmsk(ji+2,jj  ) &
-                    &     + p_fld(ji  ,jj+1) * zsurfmsk(ji  ,jj+1) &
-                    &     + p_fld(ji+1,jj+1) * zsurfmsk(ji+1,jj+1) &
-                    &     + p_fld(ji+2,jj+1) * zsurfmsk(ji+2,jj+1) &
-                    &     + p_fld(ji  ,jj+2) * zsurfmsk(ji  ,jj+2) &
-                    &     + p_fld(ji+1,jj+2) * zsurfmsk(ji+1,jj+2) &
-                    &     + p_fld(ji+2,jj+2) * zsurfmsk(ji+2,jj+2) 
-  
-                  zsfcrs =  zsurfmsk(ji,jj  ) + zsurfmsk(ji+1,jj  ) + zsurfmsk(ji+2,jj  ) &
-                    &     + zsurfmsk(ji,jj+1) + zsurfmsk(ji+1,jj+1) + zsurfmsk(ji+2,jj+1) &
-                    &     + zsurfmsk(ji,jj+2) + zsurfmsk(ji+1,jj+2) + zsurfmsk(ji+2,jj+2) 
-                   !
-                  p_fld_crs(ii,ij) = zflcrs
-                  IF( zsfcrs /= 0.0 )  p_fld_crs(ii,ij) = zflcrs / zsfcrs
-               ENDDO      
-            ENDDO
-
+            DO jj  = nldj_crs,nlej_crs
+               ijjs = mjs_crs(jj)
+               ijje = mje_crs(jj)
+               DO ji = nldi_crs, nlei_crs
+                  ijis = mis_crs(ji)
+                  ijie = mie_crs(ji)
+
+                  zflcrs = SUM( p_fld(ijis:ijie,ijjs:ijje) * zsurfmsk(ijis:ijie,ijjs:ijje) )
+                  zsfcrs = SUM(                              zsurfmsk(ijis:ijie,ijjs:ijje) )
+
+                  p_fld_crs(ji,jj) = zflcrs
+                  IF( zsfcrs /= 0.0 )  p_fld_crs(ji,jj) = zflcrs / zsfcrs
+               ENDDO
+            ENDDO
             CALL wrk_dealloc( jpi, jpj, zsurfmsk )
+            !
 
          CASE ( 'SUM' )
